% Cours 1 Introduction au comportement
clear all;close all
%Nt=601; Nx=2001;
Nt=601; Nx=2001;
t=linspace(0,3,Nt);
t=t(2:end);
x=linspace(-10,10,Nx);
[X,T]=meshgrid(x,t);
for I=1:3
%%% initial data
uo=init(x,I);

%%% Transport dt u +  dx u =0
utransp=init(X-T,I);
figure('Name','Transport I ','NumberTitle','off')
    set(axes,'FontSize',13,'Fontname','times')
xlabel('x','Fontsize',14,'Fontname','times');
ylabel('solution','Fontsize',14,'Fontname','times');
plot(x,uo,'r','Linewidth',2)
    title('condition initiale')
axis([x(1) x(end)   min(uo)-0.1  max(uo)+0.1])
pause 
clf
for n=1:Nt-1
    plot(x,utransp(n,:),'Linewidth',2)
    %title(['t=',num2str(t(n))])
    axis([x(1) x(end)   min(uo)-0.1  max(uo)+0.1])
xlabel('x','Fontsize',14,'Fontname','times');
ylabel('solution','Fontsize',14,'Fontname','times');

    pause(0.01)
end
pause(2)
hold on
plot(x,uo,'r','Linewidth',2)
title(['t=',num2str(t(n))])
hold off
%print -depsc transportI_Sine.eps
pause(2)
figure('Name','Transport II ','NumberTitle','off')

mesh(X,T,utransp)
%set(axes,'FontSize',13,'Fontname','times')
axis([x(1) x(end) t(1) t(end)  min(uo)-0.1  max(uo)+0.1])
xlabel('x','Fontsize',14,'Fontname','times');
ylabel('t','Fontsize',14,'Fontname','times');
%print -depsc transportII_Sine.eps
pause 

%%% Ondes 
uonde=(init(X-T,I)+init(X+T,I))/2;
figure('Name','Ondes I ','NumberTitle','off')

    set(axes,'FontSize',13,'Fontname','times')
xlabel('x','Fontsize',14,'Fontname','times');
ylabel('solution','Fontsize',14,'Fontname','times');
plot(x,uo,'r','Linewidth',2)
    title('condition initiale')
axis([x(1) x(end)    min(uo)-0.1  max(uo)+0.1])
pause
clf
for n=1:Nt-1
    plot(x,uonde(n,:),'Linewidth',2)
    %title(['t=',num2str(t(n))])
    axis([x(1) x(end)   min(uo)-0.1  max(uo)+0.1])
xlabel('x','Fontsize',14,'Fontname','times');
ylabel('solution','Fontsize',14,'Fontname','times');

    pause(0.05)
end
pause%(2)
hold on
plot(x,uo,'r','Linewidth',2)
title(['t=',num2str(t(n))])
hold off
%print -depsc ondesI_Sine.eps
pause%(2)
figure('Name','Ondes II ','NumberTitle','off')

mesh(X,T,uonde)
%set(axes,'FontSize',13,'Fontname','times')
axis([x(1) x(end) t(1) t(end)  min(uo)-0.1  max(uo)+0.1])
xlabel('x','Fontsize',14,'Fontname','times');
ylabel('t','Fontsize',14,'Fontname','times');
%print -depsc ondesII_Sine.eps
pause 

%%% chaleur
%%%  

uheat=solexchaleur(X,T,I);
figure('Name','Heat I ','NumberTitle','off')

plot(x,uo,'r','Linewidth',2)
    title('condition initiale')
axis([x(1) x(end)   min(uo)-0.1  max(uo)+0.1])
hold on
pause(2)
n=1
    plot(x,uheat(n,:),'b','Linewidth',2)
    title(['t=',num2str(t(n))])
    axis([x(1) x(end)   min(uo)-0.1  max(uo)+0.1])
xlabel('x','Fontsize',14,'Fontname','times');
ylabel('solution','Fontsize',14,'Fontname','times');

hold off
pause
for n=1:Nt-1
    plot(x,uheat(n,:),'Linewidth',2)
    %title(['t=',num2str(t(n))])
    axis([x(1) x(end)   min(uo)-0.1  max(uo)+0.1])
xlabel('x','Fontsize',14,'Fontname','times');
ylabel('solution','Fontsize',14,'Fontname','times');

    pause(0.01)
end
hold on
plot(x,uo,'r','Linewidth',2)
hold off
%print -depsc heatI_Sine.eps
pause
figure('Name','Heat II ','NumberTitle','off')

mesh(X,T,uheat)
%set(axes,'FontSize',13,'Fontname','times')
axis([x(1) x(end) t(1) t(end)  min(uo)-0.1  max(uo)+0.1])
xlabel('x','Fontsize',14,'Fontname','times');
ylabel('t','Fontsize',14,'Fontname','times');

%print -depsc heatII_Sine.eps

xp=0.5;
y=solexchaleur(xp,t,I);
figure(15)
plot(t,y,'b')


end 
% Cours n 2 retour sur le transport

%%%% Transport sur tout RR

% vers la droite dt u +  dx u =0

clear all;close all
Nt=101; Nx=4001;
t=linspace(0,3,Nt);
x=linspace(-2,2,Nx);
[X,T]=meshgrid(x,t);
I=3;
uexp=init(X-T,I);
figure(1)
    set(axes,'FontSize',13,'Fontname','times')
xlabel('x','Fontsize',14,'Fontname','times');
ylabel('solution','Fontsize',14,'Fontname','times');
plot(x,uexp(1,:),'Linewidth',2)
    title('condition initiale')
axis([x(1) x(end)   -0.1  1])
pause
clf
for n=1:Nt
    plot(x,uexp(n,:),'Linewidth',2)
    title(['t=',num2str(t(n))])
    axis([x(1) x(end)   -0.1  1])
xlabel('x','Fontsize',14,'Fontname','times');
ylabel('solution','Fontsize',14,'Fontname','times');

    pause(0.1)
end
pause
figure(2)
mesh(X,T,uexp)
%set(axes,'FontSize',13,'Fontname','times')
axis([x(1) x(end) t(1) t(end) -0.1  1]);
xlabel('x','Fontsize',14,'Fontname','times');
ylabel('t','Fontsize',14,'Fontname','times');
hold on
pause
% vers la gauche dt u -  dx u =0

uexm=init(X+T,1);
figure(1)
set(axes,'FontSize',13,'Fontname','times')
axis([x(1) x(end)   -0.1  1])
xlabel('x','Fontsize',14,'Fontname','times');
ylabel('solution','Fontsize',14,'Fontname','times');
for n=1:Nt
    plot(x,uexm(n,:),'Linewidth',2)
    title(['t=',num2str(t(n))])
    pause(0.1)
end
pause
figure(2)
mesh(X,T,uexm)
%set(axes,'FontSize',13,'Fontname','times')
axis([x(1) x(end) t(1) t(end) -0.1  1])
xlabel('x','Fontsize',14,'Fontname','times');
ylabel('t','Fontsize',14,'Fontname','times');
pause

% vers la droite dt u +  dx u =0 et dt u + 2 dx u =0


[X,T]=meshgrid(x,t);
uex1=init(X-T,1);
uex2=init(X-2*T,1);
figure(1)
set(axes,'FontSize',13,'Fontname','times')
axis([x(1) x(end)   -0.1  1])
xlabel('x','Fontsize',14,'Fontname','times');
ylabel('solution','Fontsize',14,'Fontname','times');
for n=1:Nt
    plot(x,uex1(n,:),'b',x,uex2(n,:),'r','Linewidth',2)
    legend('a=1','a=2');
    H=legend; set(H,'FontSize',14,'Fontname','times');
    title(['t=',num2str(t(n))])
    pause%(0.1)
end

% problme aux limites
% remarque : pas de condition sortante
%uexb=init(X+2-T,1).*(X+2>=T)+ init(T-X-2,1).*(T>X+2);
uexb=bdata(T-X,3).*(T>X+2);
uexinit=init(X-T,3).*(X+2>=T);
figure(2)
mesh(X,T,uexinit)
hold on
mesh(X,T,uexb)
axis([x(1) x(end) t(1) t(end) -0.1  1])
xlabel('x','Fontsize',14,'Fontname','times');
ylabel('t','Fontsize',14,'Fontname','times');
pause


